﻿
#AppName = "Application Template"
#AppVersion = "0.9.5"
#LangDefault = "default"


;константы для определения режима работы приложения
#AppMode_TDI = 1  ;многодокументный интерфейс с вкладками
#AppMode_MDI = 2  ;многодокументный интерфейс
#AppMode_SDI = 3  ;однодокументный интерфейс

;определяем режим работы приложения при помощи констант #AppMode_*
#AppMode = #AppMode_TDI


;Здесь перечисляются идентификаторы основных окон приложения
Enumeration Windows
  #WinMain
  #WinPref
  #WinAbout
  #WinTool
EndEnumeration

Enumeration Panels
;Это идентификаторы панелей настроек. Они должны следовать один за другим, так как используются в цикле.
  #PrefPnl_General
  #PrefPnl_Shortcuts
  CompilerIf Defined(ExtTools, #PB_Module)
    #PrefPnl_ExtTools
  CompilerEndIf
  CompilerIf Defined(Plugins, #PB_Module)
    #PrefPnl_Plugins
  CompilerEndIf
EndEnumeration
#PrefPanelsMaxID = #PB_Compiler_EnumerationValue - 1

;===================================================================================================

;Здесь перечисляются идентификаторы только тех меню, для которых требуется перевод на другие языки.
;Внимание!!! Новые идентификаторы для таких меню добавляйте только в конец перечисления,
;иначе придется корректировать значения ключей в языковых файлах.
;Идентификаторы остальных меню располагаются ниже.
Enumeration Menus
  #Menu_File = 1000
  #Menu_Plugins
  #Menu_Pref
  #Menu_Quit
  #Menu_ShowMainForm
  #Menu_Help
  #Menu_About
  #Menu_Window
  #Menu_Tools
  #Menu_ToolsPref
EndEnumeration

;Здесь перечисляются идентификаторы только тех меню, для которых НЕ ТРЕБУЕТСЯ перевод на другие языки.
;Порядок следования идентификаторов для таких меню не имеет значения.
;Идентификаторы остальных меню располагаются выше.
Enumeration Menus
  #TrayMenu
  #MainToolbar
  #MainMenu
EndEnumeration

CompilerIf #AppMode = #AppMode_TDI Or #AppMode = #AppMode_MDI
  Enumeration MenusTDI_MDI
    #Menu_New = 3000
    #Menu_Close
    #Menu_CloseAll
    #Menu_Previous
    #Menu_Next
  EndEnumeration
  
  CompilerIf #AppMode = #AppMode_MDI
    Enumeration MenusMDI
      #Menu_TileV = 3100
      #Menu_TileH
      #Menu_Cascade
    EndEnumeration
    #Menu_FirstMDI = #PB_Compiler_EnumerationValue
  CompilerEndIf      
CompilerEndIf      

;===================================================================================================

;Здесь перечисляются идентификаторы только тех гаджетов, для которых требуется перевод на другие языки.
;Внимание!!! Новые идентификаторы для таких гаджетов добавляйте только в конец перечисления,
;иначе придется корректировать значения ключей в языковых файлах.
;Идентификаторы остальных гаджетов располагаются ниже.
Enumeration Gadgets
  #PrefBtn_OK = 2000
  #PrefBtn_Cancel
  #PrefBtn_Apply
  #PrefFrm_Shortcuts
  #PrefFrm_Plugins
  #PrefFrm_General
  #PrefTxt_Language
  #PrefChB_ShowTrayIcon
  #PrefChB_MinimizeOnStart
  #PrefChB_OneInstance
  #PrefTxt_AfterRestart
  #PrefTxt_Shortcut
  #PrefBtn_Assign
  #PrefFrm_ExtTools
  #PrefBtn_AddTool
  #PrefBtn_EditTool
  #PrefBtn_DelTool
  #ToolTxt_ToolName
  #ToolTxt_ToolFile
  #ToolTxt_ToolParam
  #ToolTxt_Shortcut
  #ToolBtn_Select
EndEnumeration

;Здесь перечисляются идентификаторы только тех гаджетов, для которых НЕ ТРЕБУЕТСЯ перевод на другие языки.
;Порядок следования идентификаторов для таких гаджетов не имеет значения.
;Идентификаторы остальных гаджетов располагаются выше.
Enumeration Gadgets
  #MainStatusbar
  #PrefTreeList
  #PrefLsi_Plugins
  #PrefLsi_Shortcuts
  #PrefLsi_ExtTools
  #PrefCmB_Language
  #PrefShortcut
  #ToolStr_ToolName
  #ToolStr_ToolFile
  #ToolStr_ToolParam
  #ToolBtn_OK
  #ToolBtn_Cancel
  #ToolShortcut
  CompilerSelect #AppMode
    CompilerCase #AppMode_TDI
      #MainPanel
      
    CompilerCase #AppMode_MDI
      #MDIGadget
      
    CompilerCase #AppMode_SDI
      #MainContainer
  CompilerEndSelect
EndEnumeration

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 111
; FirstLine = 90
; Folding = -
; EnableXP