﻿
;===================================================================================================
; Включает/отключает определенные пункты меню в зависимости от текущего количества вкладок.
;===================================================================================================
Procedure DisableTDIMenus()
  Protected count = CountGadgetItems(#MainPanel)
  
  mode = Bool(count < 1)
  DisableMenuItem(#MainMenu, #Menu_Close, mode)
  DisableMenuItem(#MainMenu, #Menu_CloseAll, mode)
  
  mode = Bool(count < 2)
  DisableMenuItem(#MainMenu, #Menu_Previous, mode)
  DisableMenuItem(#MainMenu, #Menu_Next, mode)
EndProcedure

Procedure OpenTDIPanel()
  Protected idx
  
  OpenGadgetList(#MainPanel)
  AddGadgetItem(#MainPanel, -1, "")
  CloseGadgetList()
  idx = CountGadgetItems(#MainPanel) - 1
  SetGadgetState(#MainPanel, idx)
  SetGadgetItemText(#MainPanel, idx, "Panel " + idx)
  
  DisableTDIMenus()
EndProcedure

Procedure CloseTDIPanel()
  Protected count = CountGadgetItems(#MainPanel)
  Protected idx = GetGadgetState(#MainPanel)
  
  If count > 0          
    RemoveGadgetItem(#MainPanel, idx)
    
    If idx = 0
      SetGadgetState(#MainPanel, 0)
    Else
      SetGadgetState(#MainPanel, idx - 1)
    EndIf
    
    DisableTDIMenus()
  EndIf  
EndProcedure

Procedure CloseAllTDIPanels()
  ClearGadgetItems(#MainPanel)
  
  DisableTDIMenus()
EndProcedure

Procedure PreviousTDIPanel()
  Protected last = CountGadgetItems(#MainPanel) - 1
  Protected cur = GetGadgetState(#MainPanel)
  
  If last
    If cur
      SetGadgetState(#MainPanel, cur - 1)
    Else
      SetGadgetState(#MainPanel, last)
    EndIf
  EndIf
EndProcedure

Procedure NextTDIPanel()
  Protected last = CountGadgetItems(#MainPanel) - 1
  Protected cur = GetGadgetState(#MainPanel)
  
  If last
    If cur = last
      SetGadgetState(#MainPanel, 0)
    Else
      SetGadgetState(#MainPanel, cur + 1)
    EndIf
  EndIf
EndProcedure

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 34
; FirstLine = 2
; Folding = --
; EnableXP