﻿
;===================================================================================================
; Открывает модальное окно информации о программе.
;===================================================================================================
Procedure OpenWinAbout()
  If Not IsWindow(#WinAbout)
    DisableWindow(#WinMain, #True)
    
    OpenWindow(#WinAbout, 0, 0, 255, 125, GetLangRes(#Menu_About), #PB_Window_SystemMenu | #PB_Window_ScreenCentered, WindowID(#WinMain))
    
    ImageGadget(#PB_Any, 20, 15, 32, 32, ImageID(LoadImage(#PB_Any, dataDir$ + "PureBasic.ico")))
    
    TextGadget(0, 55, 15, 170, 20, #AppName, #PB_Text_Center)
    SetGadgetFont(0, 1)
    
    TextGadget(#PB_Any, 55, 35, 170, 20, "v" + #AppVersion, #PB_Text_Center)
    TextGadget(#PB_Any, 10, 60, 235, 20, "Copyright © 2016 - " + Year(Date()) + " by Alone", #PB_Text_Center)
    ButtonGadget(1, 90, 90, 75, 25, "OK", #PB_Button_Default)

    AddKeyboardShortcut(#WinAbout, #PB_Shortcut_Return, #PB_Shortcut_Return)
    AddKeyboardShortcut(#WinAbout, #PB_Shortcut_Escape, #PB_Shortcut_Escape)
  EndIf
EndProcedure

;===================================================================================================
; Закрывает модальное окно информации о программе.
;===================================================================================================
Procedure CloseWinAbout()
  RemoveKeyboardShortcut(#WinAbout, #PB_Shortcut_Return)
  RemoveKeyboardShortcut(#WinAbout, #PB_Shortcut_Escape)
  CloseWindow(#WinAbout)
  DisableWindow(#WinMain, #False)
EndProcedure

;===================================================================================================
; Обработчик событий окна информации о программе.
;===================================================================================================
Procedure WinAbout_Events(event)
  Select event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case 1
          CloseWinAbout()
      EndSelect

    Case #PB_Event_Menu
      Select EventMenu()
        Case #PB_Shortcut_Return, #PB_Shortcut_Escape
          CloseWinAbout()
      EndSelect
      
    Case #PB_Event_CloseWindow
      CloseWinAbout()
  EndSelect
  ProcedureReturn #True
EndProcedure


; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableXP