﻿
Declare OpenWinPref()
Declare OnResizeWinMain()
Declare RemoveIconFromTray()
Declare MinimizeToTray()
Declare ExitApp()

;===================================================================================================
; Открывает главное окно приложения
;===================================================================================================
Procedure OpenWinMain(x = 0, y = 0, width = 800, height = 600)
  If Not IsWindow(#WinMain)
    Protected iconPref = ImageID(LoadImage(#PB_Any, dataDir$ + "settings.ico"))
    Protected iconAbout = ImageID(LoadImage(#PB_Any, dataDir$ + "info.ico"))
    CompilerIf #AppMode = #AppMode_TDI Or #AppMode = #AppMode_MDI
      Protected iconNew = ImageID(LoadImage(#PB_Any, dataDir$ + "new.ico"))
      Protected iconNext = ImageID(LoadImage(#PB_Any, dataDir$ + "next.ico"))
      Protected iconPrev = ImageID(LoadImage(#PB_Any, dataDir$ + "prev.ico"))
      CompilerIf #AppMode = #AppMode_MDI
        Protected iconTileH = ImageID(LoadImage(#PB_Any, dataDir$ + "MDI\tileH.ico"))
        Protected iconTileV = ImageID(LoadImage(#PB_Any, dataDir$ + "MDI\tileV.ico"))
        Protected iconCascade = ImageID(LoadImage(#PB_Any, dataDir$ + "MDI\cascade.ico"))
      CompilerEndIf      
    CompilerEndIf      
    
    OpenWindow(#WinMain, x, y, width, height, #AppName + " v" + #AppVersion, #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget)
    
    If CreateImageMenu(#MainMenu, WindowID(#WinMain))
      MenuTitle(GetLangRes(#Menu_File))
      CompilerIf #AppMode = #AppMode_TDI Or #AppMode = #AppMode_MDI
        MenuItem(#Menu_New, GetLangRes(#Menu_New), iconNew)
        MenuItem(#Menu_Close, GetLangRes(#Menu_Close))
        MenuItem(#Menu_CloseAll, GetLangRes(#Menu_CloseAll))
        MenuBar()
      CompilerEndIf      
      MenuItem(#Menu_Pref, GetLangRes(#Menu_Pref) + "...", iconPref)
      MenuBar()
      MenuItem(#Menu_Quit, GetLangRes(#Menu_Quit))
      
      CompilerIf Defined(ExtTools, #PB_Module)
        MenuTitle(GetLangRes(#Menu_Tools))
        MenuItem(#Menu_ToolsPref, GetLangRes(#Menu_ToolsPref) + "...")
      CompilerEndIf
      
      CompilerIf Defined(Plugins, #PB_Module)
        MenuTitle(GetLangRes(#Menu_Plugins))
        Plugins::AddPluginsToMenu(#MainMenu)
      CompilerEndIf
      
      CompilerIf #AppMode = #AppMode_TDI Or #AppMode = #AppMode_MDI
        MenuTitle(GetLangRes(#Menu_Window))
        MenuItem(#Menu_Next, GetLangRes(#Menu_Next), iconNext)
        MenuItem(#Menu_Previous, GetLangRes(#Menu_Previous), iconPrev)
        CompilerIf #AppMode = #AppMode_MDI
          MenuBar()
          MenuItem(#Menu_TileV, GetLangRes(#Menu_TileV), iconTileV)
          MenuItem(#Menu_TileH, GetLangRes(#Menu_TileH), iconTileH)
          MenuItem(#Menu_Cascade, GetLangRes(#Menu_Cascade), iconCascade)
        CompilerEndIf              
      CompilerEndIf      
      
      MenuTitle(GetLangRes(#Menu_Help))
      MenuItem(#Menu_About, GetLangRes(#Menu_About) + "...", iconAbout)
    EndIf
    
    If CreateToolBar(#MainToolbar, WindowID(#WinMain))
      CompilerIf #AppMode = #AppMode_TDI Or #AppMode = #AppMode_MDI
        ToolBarImageButton(#Menu_New, iconNew)
        ToolBarSeparator()
      CompilerEndIf      
      ToolBarImageButton(#Menu_Pref, iconPref)
      ToolBarToolTip(#MainToolbar, #Menu_Pref, GetLangRes(#Menu_Pref))
      CompilerIf #AppMode = #AppMode_MDI
        ToolBarSeparator()
        ToolBarImageButton(#Menu_Previous, iconPrev)
        ToolBarImageButton(#Menu_Next, iconNext)
      CompilerEndIf      
    EndIf
    
    If CreateStatusBar(#MainStatusbar, WindowID(#WinMain))
      AddStatusBarField(100)
      AddStatusBarField(#PB_Ignore)
    EndIf
    
    CompilerSelect #AppMode
      CompilerCase #AppMode_TDI
        PanelGadget(#MainPanel, 2, 0, 0, 0)
        OpenTDIPanel()
        CloseGadgetList()
        
      CompilerCase #AppMode_MDI
        MDIGadget(#MDIGadget, 0, 0, 0, 0, 2, #Menu_FirstMDI, #PB_MDI_AutoSize)
        OpenMDIWindow()
        
      CompilerCase #AppMode_SDI
        ContainerGadget(#MainContainer, 0, 0, 0, 0, #PB_Container_Single)
        CloseGadgetList()
    CompilerEndSelect
    
    OnResizeWinMain()
    WindowBounds(#WinMain, 300, 200, #PB_Ignore, #PB_Ignore)
    BindEvent(#PB_Event_SizeWindow, @OnResizeWinMain())
  EndIf
EndProcedure

;===================================================================================================
; Показывает главное окно приложения, если оно свернуто в трей
;===================================================================================================
Procedure ShowWinMain()
  If isHidden
    isHidden = #False
    HideWindow(#WinMain, isHidden)
    SetWindowState(#WinMain, #PB_Window_Normal)
  EndIf
EndProcedure

;===================================================================================================
; При изменении размеров главного окна меняет размеры его дочерних элементов
;===================================================================================================
Procedure OnResizeWinMain()
  Protected y = 0, height = WindowHeight(#WinMain)
  
  If IsMenu(#MainMenu)
    height - MenuHeight()
  EndIf
  
  If IsToolBar(#MainToolbar)
    height - ToolBarHeight(#MainToolbar)
    y + ToolBarHeight(#MainToolbar)
  EndIf
  
  If IsStatusBar(#MainStatusbar)
    height - StatusBarHeight(#MainStatusbar)
  EndIf
  
  CompilerSelect #AppMode
    CompilerCase #AppMode_TDI
      ResizeGadget(#MainPanel, #PB_Ignore, y, WindowWidth(#WinMain) - 2, height)
      
    CompilerCase #AppMode_MDI
      Protected window = EventWindow()
      If FindMDIWindow(window)
        ;здесь будут функции изменения размеров гаджетов дочернего окна
      EndIf
      
    CompilerCase #AppMode_SDI
      ResizeGadget(#MainContainer, #PB_Ignore, y, WindowWidth(#WinMain), height)
  CompilerEndSelect
EndProcedure

;===================================================================================================
; Обработчик событий главного окна и трея
;===================================================================================================
Procedure WinMain_Events(event)
  Select event
    Case #PB_Event_Menu
      eventMenu = EventMenu()
      Select eventMenu
        Case #Menu_About
          OpenWinAbout()
          
        Case #Menu_ShowMainForm
          If GetOptQuad("showTrayIcon")
            ShowWinMain()  ;восстановить окно из трея
          EndIf
          
      CompilerIf Defined(ExtTools, #PB_Module)
        Case #Menu_ToolsPref
          lastPrefTreeItem = #PrefPnl_ExtTools
          OpenWinPref()
      CompilerEndIf
          
          
        Default
      CompilerIf Defined(ExtTools, #PB_Module)
          If ExtTools::IsExtToolMenuEvent(eventMenu)  ;выбран один из пунктов меню внешних инструментов
            ExtTools::CallExtToolFunction(eventMenu)
          EndIf
      CompilerEndIf
      CompilerIf Defined(Plugins, #PB_Module)
          If Plugins::IsPluginMenuEvent(eventMenu)  ;выбран один из пунктов меню плагинов
            Plugins::CallPluginFunction(eventMenu)
          EndIf
      CompilerEndIf
      EndSelect
      
    Case #PB_Event_SysTray
      If GetOptQuad("showTrayIcon")
        Select EventType()
          Case #PB_EventType_LeftDoubleClick
            ShowWinMain()  ;восстановить окно из трея
            
          Case #PB_EventType_RightClick
            ;показать всплывающее меню в трее
            DisplayPopupMenu(#TrayMenu, WindowID(#WinMain))
        EndSelect
      EndIf
      
    Case #PB_Event_MinimizeWindow
      MinimizeToTray()  ;свернуть окно в трей
      
    Case #PB_Event_RestoreWindow
      RemoveIconFromTray()  ;удалить иконку из трея
      
    Case #PB_Event_CloseWindow
      CompilerIf #AppMode = #AppMode_MDI
        Protected window = EventWindow()
        If window = #WinMain
          ExitApp()
        Else
          CloseMDIWindow(window)
        EndIf
      CompilerElse
        ExitApp()
      CompilerEndIf
  EndSelect
EndProcedure

;===================================================================================================
; Добавляет иконку приложения и соответствующее ей выпадающее меню в трей
;===================================================================================================
Procedure AddIconToTray()
  If IsSysTrayIcon(1) = 0
    CreatePopupMenu(#TrayMenu)
    MenuItem(#Menu_ShowMainForm, GetLangRes(#Menu_ShowMainForm))
    MenuItem(#Menu_Pref, GetLangRes(#Menu_Pref) + "...")
    MenuBar()
    MenuItem(#Menu_Quit, GetLangRes(#Menu_Quit))
    
    AddSysTrayIcon(1, WindowID(#WinMain), ImageID(LoadImage(#PB_Any, dataDir$ + "PureBasic.ico")))
    SysTrayIconToolTip(1, GetWindowTitle(#WinMain))
  EndIf
EndProcedure

;===================================================================================================
; Удаляет иконку приложения и соответствующее ей выпадающее меню из трея
;===================================================================================================
Procedure RemoveIconFromTray()
  If IsSysTrayIcon(1)
    FreeMenu(#TrayMenu)
    RemoveSysTrayIcon(1)
  EndIf
EndProcedure

;===================================================================================================
; Сворачивает главное окно приложения в трей
;===================================================================================================
Procedure MinimizeToTray()
  If GetOptQuad("showTrayIcon")
    isHidden = #True
    HideWindow(#WinMain, isHidden)
    AddIconToTray()
  EndIf
EndProcedure

;===================================================================================================
; Анализирует переданные параметры командной строки
;===================================================================================================
Procedure ParseCommandLine()
  Protected i = 0
  Protected param$, value$ = ""
  
  If CountProgramParameters()
    param$ = ProgramParameter(i)
    While param$
      If Left(param$, 1) = "-" Or Left(param$, 1) = "/"
        param$ = Mid(param$, 2)
      EndIf
      
      ;если передан параметр типа -f=value
      If Mid(param$, 2, 1) = "="
        value$ = Mid(param$, 3)
        param$ = Left(param$, 1)
      EndIf
      
      Select LCase(param$)
        Case "?", "h", "help"
          MessageRequester(GetLangRes(0), GetLangRes(3) + Chr(13) + Chr(13) +
                                          "-t" + Chr(9)  + Chr(9) + GetLangRes(#PrefChB_MinimizeOnStart) + Chr(13) +
                                          "-l=english" + Chr(9) + Chr(9) + GetLangRes(1) + Chr(13) +
                                          "-h, -help, -?" + Chr(9) + GetLangRes(2), #PB_MessageRequester_Info)
          
        Case "t"  ;при запуске свернуть главное окно в трей
          SetOptQuad("showTrayIcon", #True)
          MinimizeToTray()
          
        Case "l"  ;при запуске загрузить указанный язык интерфейса
          If value$ <> ""
            SetOptString("language", LCase(value$))
          EndIf
          
        Default
          Debug param$
      EndSelect
      
      i + 1
      param$ = ProgramParameter(i)
    Wend
  EndIf
EndProcedure

;===================================================================================================
; Выход из программы
;===================================================================================================
Procedure ExitApp()
  isQuit = #True
EndProcedure

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 181
; FirstLine = 177
; Folding = ----
; EnableXP