﻿
Declare ApplyPreferences()
Declare GetAvailableLanguages()
Declare SetMinimizeOnStart()
Declare ShowPanel(panelID)
Declare DisableExtToolButtons()

;===================================================================================================
; Открывает модальное окно настроек.
;===================================================================================================
Procedure OpenWinPref()
  Protected offsetX = 16           ;отступ гаджетов в панелях настроек
  Protected w1 = 150               ;ширина дерева
  Protected w2 = 450               ;ширина панелей настройки
  Protected w3 = w2 - offsetX * 2  ;максимальная ширина гаджетов в панелях настроек
  Protected h1 = 365               ;высота дерева и панелей настройки
  Protected h2 = 35                ;высота панели кнопок
  Protected idx
  
  If Not IsWindow(#WinPref)
    DisableWindow(#WinMain, #True)

    OpenWindow(#WinPref, 0, 0, w1 + w2 + 6, h1 + h2 + 6, GetLangRes(#Menu_Pref), #PB_Window_SystemMenu | #PB_Window_ScreenCentered, WindowID(#WinMain))

    TreeGadget(#PrefTreeList, 2, 2, w1, h1, #PB_Tree_AlwaysShowSelection | #PB_Tree_NoLines | #PB_Tree_NoButtons)
    AddGadgetItem(#PrefTreeList, -1, GetLangRes(#PrefFrm_General), 0, 0)
    SetGadgetItemData(#PrefTreeList, #PrefPnl_General, #PrefPnl_General)
    AddGadgetItem(#PrefTreeList, -1, GetLangRes(#PrefFrm_Shortcuts), 0, 0)
    SetGadgetItemData(#PrefTreeList, #PrefPnl_Shortcuts, #PrefPnl_Shortcuts)
    CompilerIf Defined(ExtTools, #PB_Module)
      AddGadgetItem(#PrefTreeList, -1, GetLangRes(#PrefFrm_ExtTools), 0, 0)
      SetGadgetItemData(#PrefTreeList, #PrefPnl_ExtTools, #PrefPnl_ExtTools)
    CompilerEndIf
    CompilerIf Defined(Plugins, #PB_Module)
      AddGadgetItem(#PrefTreeList, -1, GetLangRes(#PrefFrm_Plugins), 0, 0)
      SetGadgetItemData(#PrefTreeList, #PrefPnl_Plugins, #PrefPnl_Plugins)
    CompilerEndIf

    ContainerGadget(#PrefPnl_General, w1 + 4, 2, w2, h1)
    FrameGadget(#PrefFrm_General, 2, 0, w2 - 4, h1, " " + GetLangRes(#PrefFrm_General) + " ")
    TextGadget(#PrefTxt_Language, offsetX, 21, 110, 20, GetLangRes(#PrefTxt_Language) + "*")
    ComboBoxGadget(#PrefCmB_Language, offsetX + 110, 18, 150, 20)
    GetAvailableLanguages()
    CheckBoxGadget(#PrefChB_ShowTrayIcon, offsetX, 44, w3, 20, GetLangRes(#PrefChB_ShowTrayIcon))
    SetGadgetState(#PrefChB_ShowTrayIcon, GetOptQuad("showTrayIcon"))
    BindGadgetEvent(#PrefChB_ShowTrayIcon, @SetMinimizeOnStart())
    CheckBoxGadget(#PrefChB_MinimizeOnStart, offsetX + 16, 66, w3 - 16, 20, GetLangRes(#PrefChB_MinimizeOnStart))
    SetGadgetState(#PrefChB_MinimizeOnStart, GetOptQuad("minimizeOnStart"))
    SetMinimizeOnStart()
    CheckBoxGadget(#PrefChB_OneInstance, offsetX, 88, w3, 20, GetLangRes(#PrefChB_OneInstance) + "*")
    SetGadgetState(#PrefChB_OneInstance, GetOptQuad("oneInstance"))
    TextGadget(#PrefTxt_AfterRestart, offsetX, h1 - 24, w3, 20, "* - " + GetLangRes(#PrefTxt_AfterRestart))
    CloseGadgetList()
    
    ContainerGadget(#PrefPnl_Shortcuts, w1 + 4, 2, w2, h1)
    FrameGadget(#PrefFrm_Shortcuts, 2, 0, w2 - 4, h1, " " + GetLangRes(#PrefFrm_Shortcuts) + " ")
    ListIconGadget(#PrefLsi_Shortcuts, 8, 16, w2 - 16, h1 - 55, GetLangRes(7), 320, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
    AddGadgetColumn(#PrefLsi_Shortcuts, 1, GetLangRes(8), 110)
    If ExamineActions()
      While NextAction()
        idx = ActionIndex()
        AddGadgetItem(#PrefLsi_Shortcuts, -1, ActionName() + Chr(10) + ActionShortcutString())
        SetGadgetItemData(#PrefLsi_Shortcuts, idx, idx)
      Wend
    
      SetGadgetState(#PrefLsi_Shortcuts, 0)
    EndIf
    TextGadget(#PrefTxt_Shortcut, 8, h1 - 28, 180, 20, GetLangRes(#PrefTxt_Shortcut), #PB_Text_Right)
    ShortcutGadget(#PrefShortcut, 198, h1 - 31, 160, 21, 0)
    ButtonGadget(#PrefBtn_Assign, 368, h1 - 33, 75, 25, GetLangRes(#PrefBtn_Assign))
    CloseGadgetList()
    
    CompilerIf Defined(ExtTools, #PB_Module)
      ContainerGadget(#PrefPnl_ExtTools, w1 + 4, 2, w2, h1)
      FrameGadget(#PrefFrm_ExtTools, 2, 0, w2 - 4, h1, " " + GetLangRes(#PrefFrm_ExtTools) + " ")
      ListIconGadget(#PrefLsi_ExtTools, 8, 16, w2 - 16, h1 - 55, GetLangRes(4), 200, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
      AddGadgetColumn(#PrefLsi_ExtTools, 1, GetLangRes(#Menu_File), 120)
      AddGadgetColumn(#PrefLsi_ExtTools, 2, GetLangRes(8), 110)
      FillToolsList(0)
      ButtonGadget(#PrefBtn_AddTool, 8, h1 - 33, 75, 25, GetLangRes(#PrefBtn_AddTool))
      ButtonGadget(#PrefBtn_EditTool, 93, h1 - 33, 75, 25, GetLangRes(#PrefBtn_EditTool))
      ButtonGadget(#PrefBtn_DelTool, 178, h1 - 33, 75, 25, GetLangRes(#PrefBtn_DelTool))
      CloseGadgetList()
      DisableExtToolButtons()
    CompilerEndIf
    
    CompilerIf Defined(Plugins, #PB_Module)
      ContainerGadget(#PrefPnl_Plugins, w1 + 4, 2, w2, h1)
      FrameGadget(#PrefFrm_Plugins, 2, 0, w2 - 4, h1, " " + GetLangRes(#PrefFrm_Plugins) + " ")
      ListIconGadget(#PrefLsi_Plugins, 8, 16, w2 - 16, h1 - 24, GetLangRes(4), 96, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
      AddGadgetColumn(#PrefLsi_Plugins, 1, GetLangRes(5), 50)
      AddGadgetColumn(#PrefLsi_Plugins, 2, GetLangRes(6), 284)
      Plugins::FillListPlugin(#PrefLsi_Plugins)
      SetGadgetState(#PrefLsi_Plugins, 0)
      CloseGadgetList()
    CompilerEndIf

    ButtonGadget(#PrefBtn_OK, 353, 373, 75, 25, GetLangRes(#PrefBtn_OK), #PB_Button_Default)
    ButtonGadget(#PrefBtn_Cancel, 438, 373, 75, 25, GetLangRes(#PrefBtn_Cancel))
    ButtonGadget(#PrefBtn_Apply, 523, 373, 75, 25, GetLangRes(#PrefBtn_Apply))

    SetGadgetState(#PrefTreeList, lastPrefTreeItem)
    SetActiveGadget(#PrefTreeList)
    ShowPanel(GetGadgetItemData(#PrefTreeList, lastPrefTreeItem))

    AddKeyboardShortcut(#WinPref, #PB_Shortcut_Return, #PB_Shortcut_Return)
    AddKeyboardShortcut(#WinPref, #PB_Shortcut_Escape, #PB_Shortcut_Escape)
  EndIf
EndProcedure

;===================================================================================================
; Закрывает модальное окно настроек
;===================================================================================================
Procedure CloseWinPref()
  RemoveKeyboardShortcut(#WinPref, #PB_Shortcut_Return)
  RemoveKeyboardShortcut(#WinPref, #PB_Shortcut_Escape)
  CloseWindow(#WinPref)
  DisableWindow(#WinMain, #False)
EndProcedure

;===================================================================================================
; Обработчик событий окна настроек.
;===================================================================================================
Procedure WinPref_Events(event)
  Protected key, sel, shortcut

  Select event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #PrefTreeList
          If EventType() = #PB_EventType_Change
            lastPrefTreeItem = GetGadgetState(#PrefTreeList)
            ShowPanel(GetGadgetItemData(#PrefTreeList, lastPrefTreeItem))
          EndIf
          
        Case #PrefBtn_Assign
          sel = GetGadgetState(#PrefLsi_Shortcuts)
          key = GetGadgetItemData(#PrefLsi_Shortcuts, sel)
          shortcut = GetGadgetState(#PrefShortcut)
          If ChangeActionShortcut(key, shortcut)
            SetGadgetItemText(#PrefLsi_Shortcuts, sel, Hotkeys::GetShortcutString(shortcut), 1)
          EndIf
          
      CompilerIf Defined(ExtTools, #PB_Module)    
        Case #PrefBtn_AddTool
          isCreatedTool = #True        
          OpenWinTool()
          
        Case #PrefBtn_EditTool
          isCreatedTool = #False
          sel = GetGadgetState(#PrefLsi_ExtTools)
          If ExtTools::SelectExtTool(sel)
            OpenWinTool(ExtTools::ExtToolName(), ExtTools::ExtToolFileName(), ExtTools::ExtToolParams(), ExtTools::ExtToolShortcut())
          EndIf

        Case #PrefBtn_DelTool
          sel = GetGadgetState(#PrefLsi_ExtTools)
          If ExtTools::DeleteExtTool(sel)
            RemoveGadgetItem(#PrefLsi_ExtTools, sel)
            If sel
              SetGadgetState(#PrefLsi_ExtTools, sel - 1)
            Else
              SetGadgetState(#PrefLsi_ExtTools, 0)
            EndIf
            DisableExtToolButtons()
          EndIf
      CompilerEndIf

        Case #PrefBtn_OK
          ApplyPreferences()
          CloseWinPref()

        Case #PrefBtn_Cancel
          CloseWinPref()

        Case #PrefBtn_Apply
          ApplyPreferences()
      EndSelect

    Case #PB_Event_Menu
      Select EventMenu()
        Case #PB_Shortcut_Return
          If GetActiveGadget() <> #PrefBtn_Cancel
            ApplyPreferences()
          EndIf
          CloseWinPref()

        Case #PB_Shortcut_Escape
          CloseWinPref()
      EndSelect

    Case #PB_Event_CloseWindow   ;закрыть окно настроек
      CloseWinPref()
  EndSelect
EndProcedure

;===================================================================================================
; Применяет измененные настройки
;===================================================================================================
Procedure ApplyPreferences()
  Protected tmp$
  
  tmp$ = GetGadgetText(#PrefCmB_Language)
  If tmp$ <> GetOptString("language")
    SetOptString("language", tmp$)
  EndIf

  SetOptQuad("showTrayIcon", GetGadgetState(#PrefChB_ShowTrayIcon))
  If isHidden And Not GetOptQuad("showTrayIcon")
    ShowWinMain()
  EndIf

  SetOptQuad("minimizeOnStart", GetGadgetState(#PrefChB_MinimizeOnStart))

  SetOptQuad("oneInstance", GetGadgetState(#PrefChB_OneInstance))
EndProcedure

;===================================================================================================
; Заполняет выпадающий список доступных языков
;===================================================================================================
Procedure GetAvailableLanguages()
  Protected dirID, tmp$

  AddGadgetItem(#PrefCmB_Language, 0, #LangDefault)
  SetGadgetText(#PrefCmB_Language, #LangDefault)

  dirID = ExamineDirectory(#PB_Any, langDir$, "*.lng")
  If dirID
    While NextDirectoryEntry(dirID)
      If DirectoryEntryType(dirID) = #PB_DirectoryEntry_File
        tmp$ = LCase(GetFilePart(langDir$ + DirectoryEntryName(dirID), #PB_FileSystem_NoExtension))
        If tmp$ <> #LangDefault
          AddGadgetItem(#PrefCmB_Language, -1, tmp$)
          If tmp$ = GetOptString("language")
            SetGadgetText(#PrefCmB_Language, tmp$)
          EndIf
        EndIf
      EndIf
    Wend
  EndIf
EndProcedure

;===================================================================================================
; Устанавливает состояние чекбокса MinimizeOnStart в зависимости от состояния чекбокса ShowTrayIcon
;===================================================================================================
Procedure SetMinimizeOnStart()
  DisableGadget(#PrefChB_MinimizeOnStart, Bool(GetGadgetState(#PrefChB_ShowTrayIcon) = #PB_Checkbox_Unchecked))
EndProcedure

;===================================================================================================
; Выводит на первый план указанную панель настроек
;===================================================================================================
Procedure ShowPanel(panelID)
  For i = 0 To #PrefPanelsMaxID
    If IsGadget(i)
      HideGadget(i, Bool(i <> panelID))
    EndIf
  Next
EndProcedure

;===================================================================================================
; Устанавливает состояние кнопок для настройки внешних инструментов
;===================================================================================================
Procedure DisableExtToolButtons()
  Protected n = Bool(Not CountGadgetItems(#PrefLsi_ExtTools))
  
  DisableGadget(#PrefBtn_EditTool, n)
  DisableGadget(#PrefBtn_DelTool, n)
EndProcedure
; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 266
; FirstLine = 231
; Folding = ---
; EnableXP