﻿
Declare DisableExtToolButtons()

;===================================================================================================
; Заполняет список внешних инструментов и делает текущим указанный элемент списка.
;===================================================================================================
Procedure FillToolsList(idxSel)
  ClearGadgetItems(#PrefLsi_ExtTools)
  
  If ExtTools::ExamineExtTools()
    While ExtTools::NextExtTool()
      AddGadgetItem(#PrefLsi_ExtTools, -1, ExtTools::ExtToolName() + Chr(10) + GetFilePart(ExtTools::ExtToolFileName()) + Chr(10) + ExtTools::ExtToolShortcutString())
    Wend
    
    SetGadgetState(#PrefLsi_ExtTools, idxSel)
  EndIf
EndProcedure

;===================================================================================================
; Открывает модальное окно настроек внешнего инструмента.
;===================================================================================================
Procedure OpenWinTool(toolName.s = "", toolFileName.s = "", toolParams.s = "", shortcut = 0)
  If Not IsWindow(#WinTool)
    DisableWindow(#WinPref, #True)

    OpenWindow(#WinTool, 0, 0, 365, 153, GetLangRes(9), #PB_Window_SystemMenu | #PB_Window_ScreenCentered, WindowID(#WinPref))
    
    TextGadget(#ToolTxt_ToolName, 10, 13, 70, 20, GetLangRes(#ToolTxt_ToolName) + ":")
    StringGadget(#ToolStr_ToolName, 80, 10, 276, 20, toolName)
    
    TextGadget(#ToolTxt_ToolFile, 10, 38, 70, 20, GetLangRes(#ToolTxt_ToolFile) + ":")
    StringGadget(#ToolStr_ToolFile, 80, 35, 200, 20, toolFileName)
    ButtonGadget(#ToolBtn_Select, 282, 35, 75, 20, GetLangRes(#ToolBtn_Select) + "...")
    
    TextGadget(#ToolTxt_ToolParam, 10, 63, 70, 20, GetLangRes(#ToolTxt_ToolParam) + ":")
    StringGadget(#ToolStr_ToolParam, 80, 60, 276, 20, toolParams)
    
    TextGadget(#ToolTxt_Shortcut, 10, 88, 180, 20, GetLangRes(#ToolTxt_Shortcut) + ":")
    ShortcutGadget(#ToolShortcut, 80, 85, 276, 20, shortcut)
    
    ButtonGadget(#ToolBtn_OK, 197, 120, 75, 25, GetLangRes(#PrefBtn_OK), #PB_Button_Default)
    ButtonGadget(#ToolBtn_Cancel, 282, 120, 75, 25, GetLangRes(#PrefBtn_Cancel))
    
    SetActiveGadget(#ToolStr_ToolName)
    
    AddKeyboardShortcut(#WinTool, #PB_Shortcut_Return, #PB_Shortcut_Return)
    AddKeyboardShortcut(#WinTool, #PB_Shortcut_Escape, #PB_Shortcut_Escape)
  EndIf    
EndProcedure

;===================================================================================================
; Закрывает модальное окно настроек внешнего инструмента.
; При нулевом значении параметра 'mode' окно закрывается без сохранения.
;===================================================================================================
Procedure CloseWinTool(mode = 1)
  Protected sel, toolName$, fileName$, param$, shortcut 
  
  If mode
    toolName$ = GetGadgetText(#ToolStr_ToolName)
    If toolName$ = ""
      SetActiveGadget(#ToolStr_ToolName)
      ProcedureReturn 
    EndIf
    
    fileName$ = GetGadgetText(#ToolStr_ToolFile)
    If fileName$ = ""
      SetActiveGadget(#ToolStr_ToolFile)
      ProcedureReturn 
    EndIf
    
    param$ = GetGadgetText(#ToolStr_ToolParam)
    shortcut = GetGadgetState(#ToolShortcut)
    
    If isCreatedTool
      FillToolsList(ExtTools::CreateExtTool(toolName$, fileName$, param$, shortcut))
      DisableExtToolButtons()
    Else
      sel = GetGadgetState(#PrefLsi_ExtTools)
      If ExtTools::ChangeExtTool(sel, toolName$, fileName$, param$, shortcut)
        SetGadgetItemText(#PrefLsi_ExtTools, sel, ExtTools::ExtToolName() + Chr(10) + GetFilePart(ExtTools::ExtToolFileName()) + Chr(10) + ExtTools::ExtToolShortcutString())
      EndIf
    EndIf
  EndIf
  
  RemoveKeyboardShortcut(#WinTool, #PB_Shortcut_Return)
  RemoveKeyboardShortcut(#WinTool, #PB_Shortcut_Escape)
  CloseWindow(#WinTool)
  DisableWindow(#WinPref, #False)
EndProcedure

;===================================================================================================
; Обработчик событий окна настроек внешнего инструмента.
;===================================================================================================
Procedure WinTool_Events(event)
  Protected file$
  
  Select event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #ToolBtn_Select
          file$ = OpenFileRequester(GetLangRes(10), "", "All files|*.*", 0)
          If file$ <> ""
            SetGadgetText(#ToolStr_ToolFile, file$)
          EndIf
          
        Case #ToolBtn_OK
          CloseWinTool()

        Case #ToolBtn_Cancel
          CloseWinTool(0)
      EndSelect

    Case #PB_Event_Menu
      Select EventMenu()
        Case #PB_Shortcut_Return
          CloseWinTool()

        Case #PB_Shortcut_Escape
          CloseWinTool(0)
      EndSelect

    Case #PB_Event_CloseWindow   ;закрыть окно
      CloseWinTool(0)
  EndSelect
EndProcedure


; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP